Skip to main content

Priority_queue Question 2

 Leetcode 1942 The Number of the Smallest Unoccupied Chair

There is a party where n friends numbered from 0 to n - 1 are attending. There is an infinite number of chairs in this party that are numbered from 0 to infinity. When a friend arrives at the party, they sit on the unoccupied chair with the smallest number.

For example, if chairs 0, 1, and 5 are occupied when a friend comes, they will sit on chair number 2.

When a friend leaves the party, their chair becomes unoccupied at the moment they leave. If another friend arrives at that same moment, they can sit in that chair.

You are given a 0-indexed 2D integer array times where times[i] = [arrivali, leavingi], indicating the arrival and leaving times of the ith friend respectively, and an integer targetFriend. All arrival times are distinct.

Return the chair number that the friend numbered targetFriend will sit on.

Constraints:

n == times.length

2 <= n <= 10^4

times[i].length == 2

1 <= arrivali < leavingi <= 10^5

0 <= targetFriend <= n - 1

Each arrivali time is distinct.


Analysis:

The order of the available seats is one of the keys to solve this problem.

As the friends come and leave the party, the available seats are changing dynamically. So we need to maintain a list of available seats. Since the smallest one will be picked up, the list of available seats need to be sorted. Thus, pq can be used for this purpose.

But this is not enough. When one friend comes, all the previous friends having an earlier exit time had left the party, which will generate more available seats. So we need to

1. record the data pair <exit time, occupied seat> for each friend at the party currently; 

2. if these data pair are sorted, then it will be convenient to remove the data pair having an earlier exit time.

Based on 1 & 2, a second pq can be used to store the data pairs.

To make a summary, when a friend comes to the party,

1. check the second pq, pop out all the data pair having an earlier exit time (which will generate all the available seats as well), and save the seats into the first pq;

2. if the coming time is the same as that of the targetFriend, then we just need to check the first pq. If not empty, then just pick up the first one (smallest one); if empty, need to pick up the next available seat (here we need a global variable for this);

3. if the coming time is smaller than that of the targetFriend, (since we have already done 1), we need to assign one seat to the coming friend. The way to assign the seat is the same as 2. Then store the new data pair <exit time, seat> to the second pq. And also update the first pq or the next seat if necessary.


See the code below:

public:
    typedef pair<int, int> pr;
    int smallestChair(vector<vector<int>>& times, int targetFriend) {
        int res = 0, cur = 0, tf = times[targetFriend][0];
        sort(times.begin(), times.end());
        // sorted available seats
        priority_queue<int, vector<int>, greater<int>> pq1;
        // <exit time, occupied seat>
        priority_queue<pr, vector<pr>, greater<pr>> pq2;
        for(auto &a : times) {
            // update the available seats
            while(pq2.size() && pq2.top().first <= a[0]) {
                auto t = pq2.top();
                pq2.pop();
                pq1.push(t.second);
            }
            // find and pick up the smallest available seat
            if(a[0] == tf) {
                if(pq1.size()) res = pq1.top();
                else res = cur;
                break;
            }
            // assign the smallest available seat and save
            if(pq1.size()) {
                auto t = pq1.top();
                pq1.pop();
                pq2.push({a[1], t});
            }
            else {
                pq2.push({a[1], cur++});
            }
        }
        return res;
    }
};


Upper Layer




Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...